#!/bin/bash

# start local distributed test in one terminal

# random port number
let ps=$RANDOM+3000
let worker0=ps+1
let worker1=ps+2

train_dir="${HOME}/train/resnet_v2_50/${ps}"

ps_hosts="localhost:${ps}"
worker_hosts="localhost:${worker0},localhost:${worker1}"

# queue mode
#cmd="python -u ./letrain.py --train_dir=${train_dir} --model_name=resnet_v2_50 --data_dir=/nfsdata/share-read-only/datasets --data_file=ILSVRC2012 --num_clones=1 --learning_rate=0.001 --max_train_data_size=1000 --batch_size=32 --num_clones=1 --updater=cyclic --sync_replicas=False --ps_worker_sync_interval=1 --ps_hosts=${ps_hosts} --worker_hosts=${worker_hosts} --log_every_n_steps=10 --max_number_of_steps=1000"

#cmd="python -u ./letrain.py --train_dir=${train_dir} --dataset_name=imagenet --dataset_split_name=train --dataset_dir=/nfsdata/share-read-only/datasets/ILSVRC2012 --model_name=resnet_v2_50 --reader_def=${HOME}/temp/customized/get_data.py --model_def=${HOME}/temp/customized/get_loss.py --learning_rate=0.001 --max_train_data_size=1000 --batch_size=32 --num_clones=1 --updater=cyclic --sync_replicas=False --ps_worker_sync_interval=1 --ps_hosts=${ps_hosts} --worker_hosts=${worker_hosts} --log_every_n_steps=10 --max_number_of_steps=1000"

#cmd="python -u ./letrain.py --train_dir=${train_dir} --dataset_name=imagenet --dataset_split_name=train --dataset_dir=/nfsdata/share-read-only/datasets/ILSVRC2012 --model_name=resnet_v2_50 --task=imagenet --learning_rate=0.001 --max_train_data_size=1000 --batch_size=32 --num_clones=1 --updater=cyclic --sync_replicas=False --ps_worker_sync_interval=1 --ps_hosts=${ps_hosts} --worker_hosts=${worker_hosts} --log_every_n_steps=10 --max_number_of_steps=1000"

#cmd="python -u ./letrain.py --train_dir=${train_dir} --dataset_dir=/nfsdata/share-read-only/datasets/ILSVRC2012 --model_name=resnet_v2_50 --task=imagenet --learning_rate=0.001 --max_train_data_size=1000 --batch_size=32 --num_clones=1 --ps_hosts=${ps_hosts} --worker_hosts=${worker_hosts} --log_every_n_steps=10 --max_number_of_steps=1000"

cmd="nice python -u ./letrain.py --train_dir=${train_dir} --dataset_dir=/nfsdata/share-read-only/datasets/ILSVRC2012 --model_name=resnet_v2_50 --task=imagenet --learning_rate=0.1 --max_train_data_size=1000 --batch_size=32 --num_clones=1 --updater=cyclic --sync_replicas=True --ps_worker_sync_interval=0 --ps_hosts=${ps_hosts} --worker_hosts=${worker_hosts} --log_every_n_steps=10 --max_number_of_steps=1000"


mkdir -p ${train_dir}
rm -rf ${train_dir}/*

(
# start ps
CUDA_VISIBLE_DEVICES='' ${cmd} --job_name=ps --task_index=0 2>&1 | tee ${train_dir}/translate_ps.log
) & (
# start worker0
CUDA_VISIBLE_DEVICES=0 ${cmd} --job_name=worker --task_index=0 2>&1 | tee ${train_dir}/translate_worker0.log
) & (
# start worker1
CUDA_VISIBLE_DEVICES=1 ${cmd} --job_name=worker --task_index=1 2>&1 | tee ${train_dir}/translate_worker1.log
)
