# -----------------------------------------------------------
# Copyright (c) 2018 Lenovo AI Platform. All Rights Reserved.
# -----------------------------------------------------------
""" util file for all inference. """

from __future__ import division

import os
from os.path import isdir, join, splitext


def get_img_files(files_dir):
  if not isdir(files_dir):
    raise ValueError("%s doesn't exist!" % str(files_dir))

  files = []
  for path, dir_list, file_list in os.walk(files_dir, topdown=False):
    for f in file_list:
      if splitext(f)[1].lower() in ['.jpg', '.png', '.bmp', '.jpeg']:
        files.append(join(path, f))

  return files


def output_to_file(contents, filename):
  if isinstance(contents, dict):
    with open(filename, 'a') as f:
      for k, v in contents.iteritems():
        f.write(k + '  ' + v + '\n')
  elif isinstance(contents, list):
    with open(filename, 'a') as f:
      for v in contents:
        f.write(v + '\n')
  elif isinstance(contents, str):
    with open(filename, 'a') as f:
      f.write(contents) 
